# A quoi sert yield ? : https://bit.ly/3fI0u9a

def playHead(max, numeroPixel=0, composanteCouleur=0):
    '''
    Tête de lecture sur l'image
    Retourne un tuple composé du numéro de pixel et du 
    numéro associé à la composante couleur (R, V, B) traités
    Rouge:0 Vert:1 Bleu:2
    :param max: nombre de pixels de l'image
    :param numeroPixel: numéro du pixel dans l'image
    :param composanteCouleur: R:0, V:1, B:2
    '''
    octetCourant = (numeroPixel, composanteCouleur) # tuple renvoyé par yield
    i = 0
    # i et octetCourant sont mémorisés entre deux appels !
    while i < max: # on test si on est à la fin de l'image
        yield octetCourant # on retourne le tuple 'octetCourant' et on sort
        if octetCourant[1] == 2: # on reprendra ici au prochain appel
            octetCourant = (octetCourant[0]+1, 0)
        else:
            octetCourant = (octetCourant[0], octetCourant[1]+1)
        i += 1
    
# Tests
#%%
g = playHead(12)
for _ in range(12):
    print(next(g))